
# thimble

  A scaffolding tool that grows with you

  ![]

## TODO

- Add the remaining commands
  - [x] USAGE   (with markdown-cli support)
  - [x] PROMPT  (with markdown-cli support)
  - [x] CONFIRM (with markdown-cli support)
  - [x] MERGETOOL
  - [x] RENAME
  - [x] PASSWORD
  - [x] WARN
  - [x] INFO
  - [x] TEMPLATE
  - [x] MAP
- [x] Clean-up the prompt (PROMPT, CONFIRM)
- [x] treeify before and after filesystem states
- [x] Setup the thimble-run and examples
- [x] thimble-setup(1) & thimble.state support
- [x] Support `plan` and better logging
- [x] Support defaults in PROMPT params
- [x] Support formatted commands
- [x] Support thimble.yml file
- [x] thimble-get(1) support
- [x] thimble-list(1) support
- [x] thimble-setup(1) with remote support & run support
- [x] thimble-reveal(1)
- [x] TRANSFER => ADD
- [x] Fix command tests
- [x] Cleanup NPM dependencies
- [x] Better logging for commands like RUN

**Later**

- [ ] Split out commands into thimble-kit
- [ ] thimble-show(1)

## Example Flows

### module: Create a new node_module

  1. Ask a few questions:

    - What would you like to name this module?
    - What does this module do?
    - Is this a private module?
    - What's your email?
    - What's your name?

  2. Write a bunch of files:

    TRANSFER('./module', '.', answers)

  3. npm install

    RUN('npm', 'install')

  5. Tell users how to get started:

    USAGE
      This is how to use this module in a nice way

### lint: Add standard linting to the project

   1. Write package.json
   2. Run npm install
   2. Tell users how to use this

### mocha: Add mocha testing to your project

  1. Take a look at the names in your src/ directory

    TEMPLATE test/\*.js mocha/test.js => TEMPLATE('test/*.js', 'mocha/test.js')

  2. Write all those files to test/{file.name}.js with a template
  3. Write to package.json & mocha.opts
  4. Run npm install
  5. Tell the user how to use this

### circle: Add circleci.com to your project

  1. Prompt to fill in CircleCI token
  2. Prompt to fill in environment variables
  3. Enable the project in CircleCI

    POST https://circleci.com/api/create { test: $test }
    POST()

  4. Write circle.yml script
  5. Write run scripts to package.json
  6. Add badge to Readme.md
  7. Tell users how to use it

### coveralls: Add coveralls.io to the project

  1. Fill in any environment variables and tokens
  2. Enable coveralls via the API
  3. Update one of the CIs to include the build
  4. Add badge to Readme.md
  5. Tell users how to do it

### greenkeeper: Add greenkeeper.io to your project

  1. Figure out what the repository is
  2. Run greenkeeper login
  3. Run greenkeeper enable
  4. Tell users how to use it

### drone: Add drone.io to your project

### aircover: Add aircover.co to your project

### docker: Create a Dockerfile for a node.js project

### flow: Add flowtype to your project

### surge: Publish your site easily with surge.sh

  1. Ask for the domain
  2. Write to package.json
  3. Write CNAME file
  4. Run surge
  5. Tell users how to use it

### docpress: Create beautiful sites from markdown files

## License

MIT
