/**
 * Module dependencies
 */

const resolve = require('../utils/resolve')
const isArray = Array.isArray
const path = require('path')
const cwd = process.cwd()
const co = require('co')

/**
 * Export `List`
 */

module.exports = co.wrap(List)

/**
 * Initialize `List`
 */

function * List ({ root, paths = ['node_modules'] }) {
  paths = isArray(paths) ? paths : [ paths ]
  paths = paths.map(p => path.resolve(root, p))
  return yield resolve(paths)
}
