/**
 * Module dependencies
 */

const { password } = require('../utils/prompt')
const encrypt = require('../utils/encrypt')
const decrypt = require('../utils/decrypt')
const File = require('../commands/file')
const mkdir = require('co-mkdirp')
const Get = require('./get')
const path = require('path')
const fs = require('co-fs')
const cwd = process.cwd()
const co = require('co')

/**
 * Export `setup`
 */

module.exports = co.wrap(setup)

/**
 * Initialize `setup`
 */

function * setup ({ statepath }) {
  const relative = path.relative(cwd, statepath)

  const exists = yield fs.exists(statepath)
  if (!exists) throw new Error(`${relative} doesn't exist!`)

  const contents = yield fs.readFile(statepath)
  const pass = yield password(`What's the password to your thimble.state file?`)
  return JSON.parse(decrypt(contents, pass))
}
