/**
 * Module dependencies
 */

let co = require('co')

/**
 * Export `Command`
 */

module.exports = Command

/**
 * Commands
 */

let commands = {
  TRANSFORM: require('./transform'),
  MERGETOOL: require('./mergetool'),
  PASSWORD: require('./password'),
  TEMPLATE: require('./template'),
  CONFIRM: require('./confirm'),
  PROMPT: require('./prompt'),
  RENAME: require('./rename'),
  WRITE: require('./write'),
  USAGE: require('./usage'),
  MERGE: require('./merge'),
  WARN: require('./warn'),
  INFO: require('./info'),
  FILE: require('./file'),
  READ: require('./read'),
  ADD: require('./add'),
  RUN: require('./run'),
  MAP: require('./map')
}

/**
 * Initialize `Command`
 */

function Command (params) {
  let inst = {}

  for (let command in commands) {
    if (typeof commands[command] !== 'function') {
      throw new Error(`${command} is not a function`)
    }
    inst[command] = co.wrap(commands[command](params))
  }

  return inst
}
