/**
 * Module dependencies
 */

const flatten = require('lodash.flatten')
const assign = require('object-assign')
const Template = require('./template')
const Write = require('./write')
const Read = require('./read')
const path = require('path')

/**
 * Export `Map`
 */

module.exports = Map

/**
 * Initialize `Map`
 */

function Map (params) {
  const READ = Read(params)
  const TEMPLATE = Template(params)
  const { root, directory } = params
  const WRITE = Write(params)

  return function * map (from, template, answers = {}) {
    template = path.resolve(directory, template)
    from = path.resolve(root, from)
    const files = yield READ(from)
    const mapped = yield TEMPLATE(files, template, answers)
    return yield WRITE(mapped)
  }
}
