/**
 * Module dependencies
 */

let Overwrite = require('./overwrite')
let mergin = require('mergin')
let Write = require('./write')
let File = require('./file')
let path = require('path')

/**
 * Export `Merge`
 */

module.exports = Merge

/**
 * Initialize `Merge`
 */

function Merge ({ root, directory }) {
  let OVERWRITE = Overwrite({ root, directory })
  let FILE = File({ root, directory })

  return function * merge (files, to = './') {
    files = yield files.map(function * (file) {
      if (file.isDirectory()) return
      let outpath = path.resolve(root, to, file.relative)
      let orig = yield FILE(outpath)
      let merged = mergin(file.basename, orig.contents.toString(), file.contents.toString())
      if (merged) {
        file.contents = new Buffer(merged)
        yield OVERWRITE(file, to)
      } else {
        return [ orig, file ]
      }
    })

    // only return unmerged
    return files.filter(file => !!file)
  }
}
