/**
 * Module Dependencies
 */

let flatten = require('lodash.flatten')
let parent = require('glob-parent')
let Glob = require('../utils/glob')
let File = require('./file')
let isArray = Array.isArray
let path = require('path')
let fs = require('co-fs')

/**
 * Export `Read`
 */

module.exports = Read

/**
 * Read
 */

function Read ({ root, directory }) {
  let file = File({ root, directory })

  return function * readfiles (filepath) {
    let files = isArray(filepath) ? filepath : [filepath]
    files = yield files.map(read)
    return flatten(files)
  }

  function * read (filepath) {
    let glob = path.resolve(root, filepath)

    try {
      let stat = yield fs.stat(glob)
      glob = stat.isDirectory() ? glob + '/**' : glob
    } catch (e) {}

    let paths = yield Glob(glob, { cwd: root, dot: true })
    return yield paths.map(path => file(path, parent(glob)))
  }
}
