/**
 * Module dependencies
 */

const flatten = require('lodash.flatten')
const Transform = require('./transform')
const assign = require('object-assign')
const Read = require('./read')
const File = require('./file')
const path = require('path')

/**
 * Export `Template`
 */

module.exports = Template

/**
 * Initialize `Template`
 */

function Template (params) {
  const READ = Read(params)
  const TRANSFORM = Transform(params)
  const FILE = File(params)
  const { directory } = params

  return function * template (files, template, answers = {}) {
    let tpl = yield FILE(template)
    let transformed = yield files.map(function * (file) {
      let obj = assign({}, answers, { file: file.clone() })
      return yield TRANSFORM(tpl.clone(), obj)
    })
    return flatten(transformed)
  }
}
