/**
 * Module dependencies
 */

let fs = require('co-fs')

/**
 * Export `Changed`
 */

module.exports = Changed

/**
 * Initialize `Changed`
 */

function * Changed (paths, since) {
  since = new Date(since)

  let stats = yield paths.map(p => fs.stat(p))
  let changed = []

  for (let i = 0, stat; stat = stats[i]; i++) {
    let ms = new Date(stat.mtime) - since
    // give stat a window of +-1 seconds
    if (ms < 1000 && ms > -1000) {
      changed.push(paths[i])
    }
  }

  return changed
}
