/**
 * Module Dependencies
 */

let fs = require('fs-extra')

/**
 * Export `copy`
 */

module.exports = copy

/**
 * Copy files / directories
 *
 * @param {String} src
 * @param {String} dest
 */

function copy (src, dest) {
  return function (fn) {
    fs.copy(src, dest, { filter: filter(src) },fn)
  }
}

function filter (base) {
  return function exclude (path) {
    // exclude git so NPM doesn't complain
    if (path === base + '/.git') return false
    if (path === base + '/node_modules') return false
    return true
  }
}
