/**
 * Export `extract`
 */

module.exports = extract

/**
 * Extract keys from AST
 */

function extract (ast) {
  let out = []

  if (ast.type === 'block') {
    out = out.concat(props(ast.open[0].trim()))
  } else if (ast.type === 'marker') {
    out = out.concat(props(ast.params[0].trim()))
  }

  if (!ast.children || !ast.children.length) {
    return out
  }

  for (let child of ast.children) {
    out = out.concat(extract(child))
  }

  return out
}
