/**
 * Module Dependencies
 */

let props = require('component-props')
let parse = require('blocktree')

/**
 * Export `Parse`
 */

module.exports = Parse

/**
 * Parse
 */

function Parse (file) {
  let ast = {}

  // build the ASTs
  if (file.contents) ast.contents = AST(file.contents.toString())
  if (file.path) ast.path = AST(file.path)

  return ast
}

/**
 * Simple mustache parser
 *
 * @param {String} str
 * @return {Object}
 */

function AST (str) {
  return parse(str, {
    open: /\{\{\#([^\}]+)\}\}/,
    close: /\{\{\/([^\}]+)\}\}/,
    marker: /\{\{([^\}]+)\}\}/
  })
}
