/**
 * Module Dependencies
 */

const path = require('path')
const glob = require('glob')
const co = require('co')

/**
 * Export `Read`
 */

module.exports = co.wrap(Directory)

/**
 * Ignores
 */

const ignores = [
  'node_modules/**', 'bower_components/**',
  '.git/**', '.hg/**', '.svn/**', '**/.DS_Store',
  '**/.swp', '**/thumbs.db', '**/desktop.ini',
  '**/npm-debug.log'
]

/**
 * Directory
 */

function * Directory (dir) {
  let files = yield (fn) => glob('**', { nodir: true, ignore: ignores, dot: true, cwd: dir }, fn)
  return files.map(file => path.resolve(dir, file))
}
