/**
 * Module Dependencies
 */

let template = require('./template')

/**
 * Export `stringify`
 */

module.exports = stringify

/**
 * Stringify
 */

function stringify (ast, answers) {
  out = []

  switch (ast.type) {
    case 'text':
      out.push(ast.value)
      break
    case 'block':
      if (!answers[ast.open[0]]) {
        return out.join('')
      }
      break
    case 'marker':
      let str = template(ast.params[0])(answers)
      if (str !== undefined) out.push(str)
      break
  }

  if (!ast.children || !ast.children.length) {
    return out.join('')
  }

  for (let child of ast.children) {
    out = out.concat(stringify(child, answers))
  }

  return out.join('')
}
