/**
 * Module dependencies
 */

const treeify = require('treeify')
const set = require('getp/set')
const isArray = Array.isArray
const getp = require('getp')
const path = require('path')
const cwd = process.cwd()

/**
 * Export `Tree`
 */

module.exports = Tree

/**
 * Initialize `Tree`
 */

function Tree (files, root) {
  return treeify.asTree(tree(files, root || cwd))
}

/**
 * Object to Tree
 */

function tree (files, root) {
  files = isArray(files) ? files : [ files ]

  let out = {}
  let o = {}
  files.forEach(function (file) {
    let parts = file.split(path.sep).filter(Boolean)
    if (getp(o, parts, false) == null) {
      set(o, parts, null)
    }
  })
  out[root] = o
  return out
}
